/**
 *  Copyright (C) 2010 Orbeon, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify it under the terms of the
 *  GNU Lesser General Public License as published by the Free Software Foundation; either version
 *  2.1 of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU Lesser General Public License for more details.
 *
 *  The full text of the license is available at http://www.gnu.org/copyleft/lesser.html
 */
package org.orbeon.oxf.xforms.analysis

import org.orbeon.saxon.dom4j.DocumentWrapper
import org.orbeon.oxf.xforms.XFormsStaticState
import org.orbeon.oxf.util.PropertyContext


class StaticStateContext(val staticState: XFormsStaticState, val controlsDocument: DocumentWrapper, val index: Int) {
    // this would just be used by the XPath cache for statistics, just don't care for now
    val propertyContext = new PropertyContext {
        def getAttribute(key: Any) = null
        def setAttribute(key: Any, o: Any) = ()
    }
}